"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var PropTypes = _interopRequireWildcard(require("prop-types"));

var _semanticUiReact = require("semantic-ui-react");

var _cardsy = _interopRequireDefault(require("cardsy"));

var _creditCardType = _interopRequireDefault(require("credit-card-type"));

var _styleMap = _interopRequireDefault(require("../styleMap"));

var _Validator = _interopRequireDefault(require("../validation/Validator"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var LabeledInput =
/*#__PURE__*/
function (_React$Component) {
  _inherits(LabeledInput, _React$Component);

  function LabeledInput() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, LabeledInput);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(LabeledInput)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "state", {
      hasValidValue: true,
      hasFocus: false,
      hasBeenFocused: false
    });

    _defineProperty(_assertThisInitialized(_this), "onInputBlur", function () {
      var _this$props = _this.props,
          allowEmptyValue = _this$props.allowEmptyValue,
          countryCode = _this$props.countryCode,
          creditCardNumber = _this$props.creditCardNumber,
          maxValue = _this$props.maxValue,
          minLength = _this$props.minLength,
          minValue = _this$props.minValue,
          validation = _this$props.validation,
          value = _this$props.value;

      _this.setState({
        hasFocus: false
      });

      if (allowEmptyValue && !value) {
        return;
      }

      if (validation) {
        var hasValidValue = _Validator.default.validateValue(value, validation, minValue, maxValue, countryCode, minLength, creditCardNumber);

        _this.setState({
          hasValidValue: hasValidValue
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "onInputFocus", function () {
      _this.setState({
        hasValidValue: true,
        hasFocus: true,
        hasBeenFocused: true
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onInputChange", function (_ref) {
      var value = _ref.target.value;
      var _this$props2 = _this.props,
          onValueChange = _this$props2.onValueChange,
          validation = _this$props2.validation;

      if (validation === 'creditCardNumber') {
        onValueChange(_cardsy.default.format.number(value));
      } else if (validation === 'creditCardExpiration') {
        var expiryRegExp = /^(\d{2})\/(\d{2})$/;
        var expiryMatches = value.match(expiryRegExp);
        var expiryStr = expiryMatches ? "".concat(expiryMatches[1], " / ").concat(expiryMatches[2]) : value;
        onValueChange(_cardsy.default.format.expiryString(expiryStr));
      } else if (validation === 'creditCardVerificationCode') {
        onValueChange(_cardsy.default.format.cvc(value));
      } else {
        onValueChange(value);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "getInputType", function () {
      var _this$props3 = _this.props,
          type = _this$props3.type,
          validation = _this$props3.validation;

      if (type) {
        return type;
      }

      switch (validation) {
        case 'emailAddress':
          return 'email';

        case 'phoneNumber':
          return 'tel';

        case 'url':
          return 'url';

        default:
          return 'text';
      }
    });

    _defineProperty(_assertThisInitialized(_this), "getIconName", function () {
      var _this$props4 = _this.props,
          icon = _this$props4.icon,
          validation = _this$props4.validation,
          validationErrorIcon = _this$props4.validationErrorIcon,
          validationSuccessIcon = _this$props4.validationSuccessIcon,
          value = _this$props4.value;
      var _this$state = _this.state,
          hasFocus = _this$state.hasFocus,
          hasBeenFocused = _this$state.hasBeenFocused,
          hasValidValue = _this$state.hasValidValue;

      if (validationErrorIcon && !hasValidValue) {
        return hasFocus ? '' : validationErrorIcon;
      }

      if (validationSuccessIcon && hasValidValue) {
        return hasFocus || !hasBeenFocused ? '' : validationSuccessIcon;
      }

      if (validation === 'creditCardNumber' && value) {
        var creditCardTypes = (0, _creditCardType.default)(value);
        var creditCardType = creditCardTypes && creditCardTypes[0] ? creditCardTypes[0].niceType : '';

        switch (creditCardType) {
          case 'Visa':
            return 'cc visa';

          case 'Mastercard':
            return 'cc mastercard';

          case 'American Express':
            return 'cc amex';

          case 'Diners Club':
            return 'cc diners club';

          case 'Discover':
            return 'cc discover';

          case 'JCB':
            return 'cc jcb';

          default:
            return 'credit card';
        }
      }

      return icon;
    });

    _defineProperty(_assertThisInitialized(_this), "getIconColor", function () {
      var _this$props5 = _this.props,
          iconColor = _this$props5.iconColor,
          validationErrorIcon = _this$props5.validationErrorIcon,
          validationSuccessIcon = _this$props5.validationSuccessIcon;
      var _this$state2 = _this.state,
          hasFocus = _this$state2.hasFocus,
          hasValidValue = _this$state2.hasValidValue;
      var hasValidationIcon = !hasFocus && (validationErrorIcon || validationSuccessIcon);

      if (hasValidationIcon && hasValidValue) {
        return 'green';
      }

      if (hasValidationIcon && !hasValidValue) {
        return 'red';
      }

      return iconColor;
    });

    _defineProperty(_assertThisInitialized(_this), "hasIcon", function () {
      var _this$props6 = _this.props,
          icon = _this$props6.icon,
          validation = _this$props6.validation,
          validationErrorIcon = _this$props6.validationErrorIcon,
          validationSuccessIcon = _this$props6.validationSuccessIcon,
          value = _this$props6.value;
      var hasValidationIcon = validationErrorIcon || validationSuccessIcon;
      var hasCreditCardIcon = validation === 'creditCardNumber' && value;
      return !!icon || hasValidationIcon || hasCreditCardIcon;
    });

    _defineProperty(_assertThisInitialized(_this), "getClassName", function () {
      var _this$props7 = _this.props,
          disabled = _this$props7.disabled,
          focus = _this$props7.focus,
          presentation = _this$props7.presentation,
          size = _this$props7.size,
          validation = _this$props7.validation,
          value = _this$props7.value;
      var hasValidValue = _this.state.hasValidValue;
      var className = "ui input ".concat(size);

      if (_this.hasIcon()) {
        if (validation === 'creditCardNumber' && value) {
          className = "".concat(className, " left icon");
        } else {
          className = "".concat(className, " right icon");
        }
      }

      if (disabled) {
        className = "".concat(className, " disabled");
      }

      if (focus) {
        className = "".concat(className, " focus");
      }

      if (!hasValidValue && presentation === 'box') {
        className = "".concat(className, " error");
      }

      return className;
    });

    _defineProperty(_assertThisInitialized(_this), "getIconStyle", function () {
      var _this$props8 = _this.props,
          validation = _this$props8.validation,
          validationErrorIcon = _this$props8.validationErrorIcon,
          validationSuccessIcon = _this$props8.validationSuccessIcon,
          value = _this$props8.value;

      if (validationErrorIcon || validationSuccessIcon) {
        return _styleMap.default.validationIcon;
      }

      if (validation === 'creditCardNumber' && value) {
        return _styleMap.default.leftIcon;
      }

      return {};
    });

    return _this;
  }

  _createClass(LabeledInput, [{
    key: "render",
    value: function render() {
      var _this$props9 = this.props,
          allowEmptyValue = _this$props9.allowEmptyValue,
          countryCode = _this$props9.countryCode,
          creditCardNumber = _this$props9.creditCardNumber,
          disabled = _this$props9.disabled,
          errorText = _this$props9.errorText,
          errorTextPosition = _this$props9.errorTextPosition,
          focus = _this$props9.focus,
          icon = _this$props9.icon,
          iconColor = _this$props9.iconColor,
          iconPosition = _this$props9.iconPosition,
          inputId = _this$props9.inputId,
          label = _this$props9.label,
          minLength = _this$props9.minLength,
          minValue = _this$props9.minValue,
          maxLength = _this$props9.maxLength,
          maxValue = _this$props9.maxValue,
          onValueChange = _this$props9.onValueChange,
          presentation = _this$props9.presentation,
          size = _this$props9.size,
          style = _this$props9.style,
          type = _this$props9.type,
          validation = _this$props9.validation,
          validationErrorIcon = _this$props9.validationErrorIcon,
          validationSuccessIcon = _this$props9.validationSuccessIcon,
          value = _this$props9.value,
          restOfProps = _objectWithoutProperties(_this$props9, ["allowEmptyValue", "countryCode", "creditCardNumber", "disabled", "errorText", "errorTextPosition", "focus", "icon", "iconColor", "iconPosition", "inputId", "label", "minLength", "minValue", "maxLength", "maxValue", "onValueChange", "presentation", "size", "style", "type", "validation", "validationErrorIcon", "validationSuccessIcon", "value"]);

      var _this$state3 = this.state,
          hasFocus = _this$state3.hasFocus,
          hasValidValue = _this$state3.hasValidValue;

      var topDivStyle = _objectSpread({}, _styleMap.default.topDiv, {}, errorTextPosition === 'bottom' ? _styleMap.default.topDivWhenErrorAtBottom : {});

      var inputLabelStyle = _objectSpread({}, _styleMap.default.inputLabel, {}, presentation === 'line' ? _styleMap.default.lineInputLabel : _styleMap.default.boxInputLabel, {}, hasFocus || value ? _styleMap.default.focusedOrValuedInputLabel : {});

      var inputStyle = _objectSpread({}, _styleMap.default.input, {}, presentation === 'line' ? _styleMap.default.lineInput : {}, {}, !hasValidValue && presentation === 'line' ? _styleMap.default.errorLineInput : {});

      var errorLabelStyle = _objectSpread({}, _styleMap.default.errorLabel, {}, errorTextPosition === 'right' ? _styleMap.default.rightErrorLabel : {}); // eslint-disable-next-line react/jsx-props-no-spreading


      return React.createElement("div", _extends({
        style: topDivStyle
      }, restOfProps), React.createElement("div", {
        className: this.getClassName()
      }, React.createElement("label", {
        className: hasFocus || value ? 'focusedOrValued' : '',
        style: inputLabelStyle,
        htmlFor: inputId
      }, label), React.createElement("input", {
        id: inputId,
        maxLength: maxLength,
        type: this.getInputType(),
        onBlur: this.onInputBlur,
        onFocus: this.onInputFocus,
        onChange: this.onInputChange,
        style: inputStyle,
        value: value
      }), this.hasIcon() ? React.createElement(_semanticUiReact.Icon, {
        color: this.getIconColor(),
        name: this.getIconName(),
        style: this.getIconStyle()
      }) : undefined), !hasValidValue && errorText ? React.createElement("div", {
        className: "ui label errorLabel ".concat(size),
        style: errorLabelStyle
      }, errorText) : undefined);
    }
  }]);

  return LabeledInput;
}(React.Component);

exports.default = LabeledInput;

_defineProperty(LabeledInput, "propTypes", {
  allowEmptyValue: PropTypes.bool,
  className: PropTypes.string,
  countryCode: PropTypes.string,
  creditCardNumber: PropTypes.string,
  disabled: PropTypes.bool,
  errorText: PropTypes.string,
  errorTextPosition: PropTypes.oneOf(['bottom', 'right']),
  focus: PropTypes.bool,
  icon: PropTypes.string,
  iconColor: PropTypes.string,
  iconPosition: PropTypes.oneOf(['left', 'right']),
  inputId: PropTypes.string.isRequired,
  label: PropTypes.string.isRequired,
  maxLength: PropTypes.number,
  maxValue: PropTypes.number,
  minLength: PropTypes.number,
  minValue: PropTypes.number,
  onValueChange: PropTypes.func.isRequired,
  presentation: PropTypes.oneOf(['box', 'line']),
  size: PropTypes.oneOf(['large', 'big', 'huge', 'massive']),
  type: PropTypes.string,
  validation: PropTypes.oneOfType([PropTypes.oneOf(['url', 'emailAddress', 'creditCardNumber', 'creditCardExpiration', 'creditCardVerificationCode', 'number', 'integer', 'alphaNumeric', 'usZipCode', 'caPostCode', 'ukPostCode', 'phoneNumber', 'usSSN', 'ipAddress', 'ipv4Address', 'ipv6Address', 'hexColor']), PropTypes.arrayOf(PropTypes.string), PropTypes.instanceOf(RegExp), PropTypes.func]),
  validationErrorIcon: PropTypes.string,
  validationSuccessIcon: PropTypes.string,
  value: PropTypes.string.isRequired
});

_defineProperty(LabeledInput, "defaultProps", {
  allowEmptyValue: false,
  className: undefined,
  countryCode: '',
  creditCardNumber: '',
  disabled: false,
  errorText: '',
  errorTextPosition: 'bottom',
  focus: false,
  icon: '',
  iconColor: undefined,
  iconPosition: 'right',
  maxLength: undefined,
  maxValue: undefined,
  minLength: undefined,
  minValue: undefined,
  presentation: 'box',
  size: 'huge',
  type: undefined,
  validation: undefined,
  validationErrorIcon: '',
  validationSuccessIcon: ''
});
//# sourceMappingURL=LabeledInput.js.map