import * as React from 'react';
import { SemanticCOLORS, SemanticICONS } from 'semantic-ui-react';
import { ValidationType } from '../validation/ValidationType';
export interface Props extends React.HTMLAttributes<HTMLDivElement> {
    allowEmptyValue: boolean;
    className?: string;
    countryCode: string;
    creditCardNumber: string;
    disabled: boolean;
    errorText: string;
    errorTextPosition: 'bottom' | 'right';
    focus: boolean;
    icon: SemanticICONS;
    iconColor: SemanticCOLORS;
    iconPosition: 'left' | 'right';
    inputId: string;
    label: string;
    maxLength?: number;
    maxValue?: number;
    minLength?: number;
    minValue?: number;
    onValueChange: (value: string) => void;
    presentation: 'box' | 'line';
    size: 'large' | 'big' | 'huge' | 'massive';
    type: string;
    validation?: ValidationType;
    validationSuccessIcon: SemanticICONS;
    validationErrorIcon: SemanticICONS;
    value: string;
}
declare type State = {
    hasValidValue: boolean;
    hasFocus: boolean;
    hasBeenFocused: boolean;
};
export default class LabeledInput extends React.Component<Props, {}> {
    static propTypes: {
        [key in keyof Props]: any;
    };
    static defaultProps: {
        allowEmptyValue: boolean;
        className: undefined;
        countryCode: string;
        creditCardNumber: string;
        disabled: boolean;
        errorText: string;
        errorTextPosition: string;
        focus: boolean;
        icon: string;
        iconColor: undefined;
        iconPosition: string;
        maxLength: undefined;
        maxValue: undefined;
        minLength: undefined;
        minValue: undefined;
        presentation: string;
        size: string;
        type: undefined;
        validation: undefined;
        validationErrorIcon: string;
        validationSuccessIcon: string;
    };
    state: State;
    onInputBlur: () => void;
    onInputFocus: () => void;
    onInputChange: ({ target: { value } }: React.ChangeEvent<HTMLInputElement>) => void;
    getInputType: () => string;
    getIconName: () => import("semantic-ui-react/dist/commonjs/generic").SemanticICONS;
    getIconColor: () => import("semantic-ui-react/dist/commonjs/generic").SemanticCOLORS;
    hasIcon: () => boolean;
    getClassName: () => string;
    getIconStyle: () => React.CSSProperties;
    render(): React.ReactElement;
}
export {};
